//=============================================================================
//  TMidiBase Implementation
//=============================================================================
#include <string.h>
#include <stdio.h>
#include <iostream.h>
#include <mcBase.h>

//=============================================================================
// constructor for class
// 28.08.2000 Adrian Meyer
//=============================================================================
TMidiBase::TMidiBase( void )
{
	fMCMessageList = 0;
	fMCMessage = new sMCMessage;
}

//=============================================================================
// destructor for class
// 28.08.2000 Adrian Meyer
//=============================================================================
TMidiBase::~TMidiBase( void )
{
	sMCMessageList* tmpMCMessageList = fMCMessageList;
	while ( tmpMCMessageList != 0 )
	{
		sMCMessageList* oldMCMessageList = tmpMCMessageList;
		tmpMCMessageList = tmpMCMessageList->Next;
		delete oldMCMessageList;
	}

	fMCMessageList = 0;
	delete fMCMessage;
}

//=============================================================================
// add Message to list
// 28.08.2000 Adrian Meyer
//=============================================================================
void TMidiBase::AddMCMessage( tMCMessage aMCMessage,  void* aUserData )
{
  sMCMessageList * tmpMessageList;
  if ( fMCMessageList != 0 )
  {
    tmpMessageList = fMCMessageList;
    while ( tmpMessageList->Next != 0 )   						// find last Message
    {
      tmpMessageList = tmpMessageList->Next;
    }
    tmpMessageList->Next = new sMCMessageList;
    tmpMessageList->Next->Message = aMCMessage;
    tmpMessageList->Next->UserData = aUserData;
		fMCMessageList->Next->Next = 0;
  }
  else
  {
    fMCMessageList = new sMCMessageList;							// add first Message
		fMCMessageList->Message = aMCMessage;
    fMCMessageList->UserData = aUserData;
		fMCMessageList->Next = 0;
  }
}

//=============================================================================
// read message for call
// 28.08.2000 Adrian Meyer
//=============================================================================
sMCMessage * TMidiBase::GetMCMessage( void )
{
  return fMCMessage;
}

//=============================================================================
// call message with fMCMessage
// 28.08.2000 Adrian Meyer
//=============================================================================
void TMidiBase::CallMCMessage( TMidiBase* aBase )
{
  sMCMessageList * tmpMessageList = fMCMessageList;
  while ( tmpMessageList != 0 )   										// loop through messages
  {
		fMCMessage->UserData = tmpMessageList->UserData;	// forward pointer to userdata
		tmpMessageList->Message( aBase, fMCMessage );     // call them
    tmpMessageList = tmpMessageList->Next;
  }
}

//=============================================================================
// call message direct
// 28.08.2000 Adrian Meyer
//=============================================================================
void TMidiBase::CallMCMessage( TMidiBase* aBase, short aClass, long aMessage, char* aText )
{
	fMCMessage->Class = aClass;
	fMCMessage->Message = aMessage;
	fMCMessage->Text = aText;
	CallMCMessage( aBase );
}
