//=============================================================================
//  TMidiDevice class definition
//=============================================================================
#include <string.h>
#include <iostream.h>
#include <mcDevice.h>


//=============================================================================
// constructor
// 20.07.2001 Adrian Meyer
//=============================================================================
TMidiDevice::TMidiDevice( const char* aName, const char* aDevice, short aType, short aPort )
{
  fName = 0;
  fDevice = 0;
  fType = aType;
  Offset = aPort;
  SetName( aName );
  SetDevice( aDevice );
}

//=============================================================================
// destructor
// 20.07.2001 Adrian Meyer
//=============================================================================
TMidiDevice::~TMidiDevice()
{
  if ( fName ) delete fName;
  if ( fDevice ) delete fDevice;
}

//=============================================================================
// set name
// 20.07.2001 Adrian Meyer
//=============================================================================
void TMidiDevice::SetName( const char* aName )
{
  if ( fName ) delete fName;
  fName = new char[ strlen( aName ) + 1 ];
  strcpy( fName, aName );
}

//=============================================================================
// read name
// 20.07.2001 Adrian Meyer
//=============================================================================
char* TMidiDevice::GetName( void )
{
  return fName;
}

//=============================================================================
// set device
// 20.07.2001 Adrian Meyer
//=============================================================================
void TMidiDevice::SetDevice( const char* aDevice )
{
  if ( fDevice ) delete fDevice;
  fDevice = new char[ strlen( aDevice ) + 1 ];
  strcpy( fDevice, aDevice );
}

//=============================================================================
// read device
// 20.07.2001 Adrian Meyer
//=============================================================================
char* TMidiDevice::GetDevice( void )
{
  return fDevice;
}

//=============================================================================
// set type
// 20.07.2001 Adrian Meyer
//=============================================================================
void TMidiDevice::SetType( short aType )
{
  fType = aType;
}

//=============================================================================
// read type
// 20.07.2001 Adrian Meyer
//=============================================================================
short TMidiDevice::GetType( void )
{
  return fType;
}

//=============================================================================
// set port
// 20.07.2001 Adrian Meyer
//=============================================================================
void TMidiDevice::SetPort( short aPort )
{
  Offset = aPort;
}

//=============================================================================
// read port
// 20.07.2001 Adrian Meyer
//=============================================================================
short TMidiDevice::GetPort( void )
{
  return (short)Offset;
}