//=============================================================================
//  TMidiDevice class definition
//=============================================================================
// Author  : Adrian Meyer
// Version : 0.3.0
// Log     :
//=============================================================================
// 20.07.2001 building class
//=============================================================================
// to do:
//=============================================================================

#ifndef __MCDEVICE__
#define __MCDEVICE__

#include <mcList.h>
const short cDTInput = 0x00;                          // device type input
const short cDTOutput = 0x7F;                         // device type output

class TMidiDevice: public TMidiItem
{
private:
  char* fName;                                        // name of the device
  char* fDevice;                                      // original device name
  short fType;                                        // type of device in/out
  // the port number will be stored in Offset of TListItem !!!
public:
                                                      // constructor
  TMidiDevice( const char* aName, const char* aDevice, short aType, short aPort );
  ~TMidiDevice();                                     // destructor

  void SetName( const char* aName );            						// set name
  char* GetName( void );                   				    // read name
  void SetDevice( const char* aDevice );         				    // set device
  char* GetDevice( void );                        		// read device
  void SetType( short aType );           						  // set type
  short GetType( void );                        			// read type
  void SetPort( short aPort );            						// set port
  short GetPort( void );                        			// read port
};

#endif