//=============================================================================
//  TMidiClasses static stuff
//=============================================================================
// Author  : Adrian Meyer
// Version : 0.2.0
// Log     :
//=============================================================================

#ifndef __MCSTATICS__
#define __MCSTATICS__

//static char* cMinorScale[12] = {"C","Db","D","Eb","E","F","Gb","G","Ab","A","Bb","B" };
static char* cMajorScale[12] = { "C","C#","D","D#","E","F","F#","G","G#","A","A#","B" };

static char* cKeySignature[15][2] = {
  {"Cb","Abm" },
  { "Gb", "Ebm" },
  { "Db", "Bbm" },
  { "Ab", "Fm" },
  { "Eb", "Cm" },
  { "Bb", "Gm" },
  { "F", "Dm" },
  { "C", "Am" },
  { "G", "Em" },
  { "D", "Bm" },
  { "A", "F#m" },
  { "E", "C#m" },
  { "B", "G#m" },
  { "F#", "D#m" },
  { "C#", "A#m" }};
static char* cKeyRemark[15] = {
  "(7 flats)",
  "(6 flats)",
  "(5 flats)",
  "(4 flats)",
  "(3 flats)",
  "(2 flats)",
  "(1 flat)",
  "",
  "(1 sharp)",
  "(2 sharps)",
  "(3 sharps)",
  "(4 sharps)",
  "(5 sharps)",
  "(6 sharps)",
  "(7 sharps)" };

static char* cControllerName[128] = {
  "Bank Select (MSB)",
  "Modulation Wheel (MSB)",
  "Breath Control (MSB)",
  "undefined (MSB)",
  "Foot Controller (MSB)",
  "Portamento Time (MSB)",
  "Data Entry (MSB)",
  "Channel Volume (MSB)",
  "Balance (MSB)",
  "undefined (MSB)",
  "Panning (MSB)",
  "Expression Controller (MSB)",
  "Effect Control 1 (MSB)",
  "Effect Control 2 (MSB)",
  "undefined (MSB)",
  "undefined (MSB)",
  "General Purpose Controller 1 (MSB)",
  "General Purpose Controller 2 (MSB)",
  "General Purpose Controller 3 (MSB)",
  "General Purpose Controller 4 (MSB)",
  "undefined (MSB)",
  "undefined (MSB)",
  "undefined (MSB)",
  "undefined (MSB)",
  "undefined (MSB)",
  "undefined (MSB)",
  "undefined (MSB)",
  "undefined (MSB)",
  "undefined (MSB)",
  "undefined (MSB)",
  "undefined (MSB)",
  "undefined (MSB)",
  "Bank Select (LSB)",
  "Modulation Wheel (LSB)",
  "Breath Control (LSB)",
  "undefined (LSB)",
  "Foot Controller (LSB)",
  "Portamento Time (LSB)",
  "Data Entry (LSB)",
  "Channel Volume (LSB)",
  "Balance (LSB)",
  "undefined (LSB)",
  "Panning (LSB)",
  "Expression Controller (LSB)",
  "Effect Control 1 (LSB)",
  "Effect Control 2 (LSB)",
  "undefined (LSB)",
  "undefined (LSB)",
  "General Purpose Controller 1 (LSB)",
  "General Purpose Controller 2 (LSB)",
  "General Purpose Controller 3 (LSB)",
  "General Purpose Controller 4 (LSB)",
  "undefined (LSB)",
  "undefined (LSB)",
  "undefined (LSB)",
  "undefined (LSB)",
  "undefined (LSB)",
  "undefined (LSB)",
  "undefined (LSB)",
  "undefined (LSB)",
  "undefined (LSB)",
  "undefined (LSB)",
  "undefined (LSB)",
  "undefined (LSB)",
  "Damper Pedal (Sustain) (off<64<=on)",
  "Portamento (off<64<=on)",
  "Sustenuto (off<64<=on)",
  "Soft Pedal (off<64<=on)",
  "Legato Footswitch (off<64<=on)",
  "Hold 2 (Sustain) (off<64<=on)",
  "Sound Controller 1 (Sound Variation) (LSB)",
  "Sound Controller 2 (Timbre) (LSB)",
  "Sound Controller 3 (Release Time) (LSB)",
  "Sound Controller 4 (Attack Time) (LSB)",
  "Sound Controller 5 (Brightness) (LSB)",
  "Sound Controller 6 (LSB)",
  "Sound Controller 7 (LSB)",
  "Sound Controller 8 (LSB)",
  "Sound Controller 9 (LSB)",
  "Sound Controller 10 (LSB)",
  "General Purpose Controller 5 (LSB)",
  "General Purpose Controller 6 (LSB)",
  "General Purpose Controller 7 (LSB)",
  "General Purpose Controller 8 (LSB)",
  "Portamento Controll (Source Note)",
  "undefined (LSB)",
  "undefined (LSB)",
  "undefined (LSB)",
  "undefined (LSB)",
  "undefined (LSB)",
  "undefined (LSB)",
  "Effects Depth 1 (LSB)",
  "Effects Depth 2 (LSB)",
  "Effects Depth 3 (LSB)",
  "Effects Depth 4 (LSB)",
  "Effects Depth 5 (LSB)",
  "Data Entry +1 (increment) (no value)",
  "Data Entry -1 (decrement) (no value)",
  "Non-Registered Parameter Number (LSB)",
  "Non-Registered Parameter Number (MSB)",
  "Registered Parameter Number (LSB)",
  "Registered Parameter Number (MSB)",
  "undefined",
  "undefined",
  "undefined",
  "undefined",
  "undefined",
  "undefined",
  "undefined",
  "undefined",
  "undefined",
  "undefined",
  "undefined",
  "undefined",
  "undefined",
  "undefined",
  "undefined",
  "undefined",
  "undefined",
  "undefined",
  "All Sound Off (Value 0)",
  "Reset All Controllers (Value 0)",
  "Local Control (off<64<=on)",
  "All Notes Off (Value 0)",
  "Omny mode Off (Value 0)",
  "Omny mode On (Value 0)",
  "Poly Mode On/Off (Value=Number of Channels)",
  "Poly Mode On (Value 0)" };

static char* cGMPatchName[128] = {
  "Acoustic Grand (Piano)",
  "Bright Acoustic (Piano)",
  "Electric Grand (Piano)",
  "Honky-Tonk (Piano)",
  "Electric Piano 1 (Piano)",
  "Electric Piano 2 (Piano)",
  "Harpsichord (Piano)",
  "Clavinet (Piano)",
  "Celesta (Chromatic Percussion)",
  "Glockenspiel (Chromatic Percussion)",
  "Music Box (Chromatic Percussion)",
  "Vibraphone (Chromatic Percussion)",
  "Marimba (Chromatic Percussion)",
  "Xylophone (Chromatic Percussion)",
  "Tubular Bells (Chromatic Percussion)",
  "Dulcimer (Chromatic Percussion)",
  "Drawbar Organ (Organ)",
  "Percussive Organ (Organ)",
  "Rock Organ (Organ)",
  "Church Organ (Organ)",
  "Reed Organ (Organ)",
  "Accoridan (Organ)",
  "Harmonica (Organ)",
  "Tango Accordian (Organ)",
  "Nylon String Guitar (Guitar)",
  "Steel String Guitar (Guitar)",
  "Electric Jazz Guitar (Guitar)",
  "Electric Clean Guitar (Guitar)",
  "Electric Muted Guitar (Guitar)",
  "Overdriven Guitar (Guitar)",
  "Distortion Guitar (Guitar)",
  "Guitar Harmonics (Guitar)",
  "Acoustic Bass (Bass)",
  "Electric Bass(finger) (Bass)",
  "Electric Bass(pick) (Bass)",
  "Fretless Bass (Bass)",
  "Slap Bass 1 (Bass)",
  "Slap Bass 2 (Bass)",
  "Synth Bass 1 (Bass)",
  "Synth Bass 2 (Bass)",
  "Violin (Solo Strings)",
  "Viola (Solo Strings)",
  "Cello (Solo Strings)",
  "Contrabass (Solo Strings)",
  "Tremolo Strings (Solo Strings)",
  "Pizzicato Strings (Solo Strings)",
  "Orchestral Strings (Solo Strings)",
  "Timpani (Solo Strings)",
  "String Ensemble 1 (Ensemble)",
  "String Ensemble 2 (Ensemble)",
  "SynthStrings 1 (Ensemble)",
  "SynthStrings 2 (Ensemble)",
  "Choir Aahs (Ensemble)",
  "Voice Oohs (Ensemble)",
  "Synth Voice (Ensemble)",
  "Orchestra Hit (Ensemble)",
  "Trumpet (Brass)",
  "Trombone (Brass)",
  "Tuba (Brass)",
  "Muted Trumpet (Brass)",
  "French Horn (Brass)",
  "Brass Section (Brass)",
  "SynthBrass 1 (Brass)",
  "SynthBrass 2 (Brass)",
  "Soprano Sax (Reed)",
  "Alto Sax (Reed)",
  "Tenor Sax (Reed)",
  "Baritone Sax (Reed)",
  "Oboe (Reed)",
  "English Horn (Reed)",
  "Bassoon (Reed)",
  "Clarinet (Reed)",
  "Piccolo (Pipe)",
  "Flute (Pipe)",
  "Recorder (Pipe)",
  "Pan Flute (Pipe)",
  "Blown Bottle (Pipe)",
  "Skakuhachi (Pipe)",
  "Whistle (Pipe)",
  "Ocarina (Pipe)",
  "Lead 1 (square) (Synth Lead)",
  "Lead 2 (sawtooth) (Synth Lead)",
  "Lead 3 (calliope) (Synth Lead)",
  "Lead 4 (chiff) (Synth Lead)",
  "Lead 5 (charang) (Synth Lead)",
  "Lead 6 (voice) (Synth Lead)",
  "Lead 7 (fifths) (Synth Lead)",
  "Lead 8 (bass+lead) (Synth Lead)",
  "Pad 1 (new age) (Synth Pad)",
  "Pad 2 (warm) (Synth Pad)",
  "Pad 3 (polysynth) (Synth Pad)",
  "Pad 4 (choir) (Synth Pad)",
  "Pad 5 (bowed) (Synth Pad)",
  "Pad 6 (metallic) (Synth Pad)",
  "Pad 7 (halo) (Synth Pad)",
  "Pad 8 (sweep) (Synth Pad)",
  "FX 1 (rain) (Synth Effects)",
  "FX 2 (soundtrack) (Synth Effects)",
  "FX 3 (crystal) (Synth Effects)",
  "FX 4 (atmosphere) (Synth Effects)",
  "FX 5 (brightness) (Synth Effects)",
  "FX 6 (goblins) (Synth Effects)",
  "FX 7 (echoes) (Synth Effects)",
  "FX 8 (sci-fi) (Synth Effects)",
  "Sitar (Ethnic)",
  "Banjo (Ethnic)",
  "Shamisen (Ethnic)",
  "Koto (Ethnic)",
  "Kalimba (Ethnic)",
  "Bagpipe (Ethnic)",
  "Fiddle (Ethnic)",
  "Shanai (Ethnic)",
  "Tinkle Bell (Percussion)",
  "Agogo (Percussion)",
  "Steel Drums (Percussion)",
  "Woodblock (Percussion)",
  "Taiko Drum (Percussion)",
  "Melodic Tom (Percussion)",
  "Synth Drum (Percussion)",
  "Reverse Cymbal (Percussion)",
  "Guitar Fret Noise (Sound Effects)",
  "Breath Noise (Sound Effects)",
  "Seashore (Sound Effects)",
  "Bird Tweet (Sound Effects)",
  "Telephone Ring (Sound Effects)",
  "Helicopter (Sound Effects)",
  "Applause (Sound Effects)",
  "Gunshot (Sound Effects)" };


#endif
