//=============================================================================
//  model view control event list
//=============================================================================
// Author  : Adrian Meyer
// Version : 0.2.1
// Log     :
//=============================================================================
// 28.03.2000 building class
// 29.03.2000 merge selected tracks in view   @#*&%!!
// 10.04.2000 detailed controller information, program change
// 10.04.2001 adding language file for property dialog
//============================================================================
// to do   :
//=============================================================================
#include <gtk/gtk.h>
#include <stdio.h>

#include "glade_interface.h"
#include "glade_support.h"

#include <mvcBase.h>
#include <mvcEventProperties.h>
#include <mcSequence.h>
#include <mcStatics.h>

class TMvcEventList: public TMvcBase
{
  private:
    GtkWidget* fWidget;                               // main widget
    int fSelectedRow;                                 // selected row
    int fRowCount;                                    // count of rows
    bool fEventFlag;                                  // react to changes on events

    TMidiSequence* fSequence;                         // last displayes sequence
    TMvcEventProperties* fEventProperties;            // event property dialog

  public:
                                                      // constructor
    TMvcEventList( GtkWidget* aWidget, TMidiSequence* aSequence );

    GtkWidget* GetWidget( void );                     // read widget
    void SetData( void );                             // set data

    TMidiEvent* GetSelectedEvent( void );             // read first selected event
    TMidiEvent* GetNextEvent( void );                 // read next event
    TMidiEvent* GetPrevEvent( void );                 // read prevois event

    void SetSelectedRow( int aRow );                  // write selected row
    void SetRowData( int aRow );                      // set data of a row
    void ValidateGui( void );                         // validate gui
    void MCMessage( TMidiBase* aMidiBase, sMCMessage* aMCMessage );

    void DeleteEvent( void );                         // delete selected event
    void AddEvent( void );                            // add new event

    void ShowEventProperties( void );                 // show event properties
};