//=============================================================================
//  model view control event properties
//=============================================================================
// Author  : Adrian Meyer
// Version : 0.2.0
// Log     :
//=============================================================================
// 04.04.2000 building class
// 07.04.2000 next and prevois event
// 09.04.2000 writing data to TMidiEvent
// 05.09.2000 create new track added
// 21.02.2001 adding triplet in note properties
//============================================================================
// to do   :
//=============================================================================
#include <gtk/gtk.h>

#include "glade_interface.h"
#include "glade_support.h"

#include <mvcBase.h>
#include <mcEvent.h>
#include <mcStatics.h>

#ifndef __MVCEVENTPROPERTIES__
#define __MVCEVENTPROPERTIES__

class TMvcEventProperties: public TMvcBase
{
  private:
    GtkWidget* wndEventProperties;                    // main window
    TMidiEvent* fEvent;                               // midi event
    GList* fNoteNames;                                // note name list
    GList* fControllerNames;                          // note name list
    GList* fGMPatchNames;                             // GM patch name list
    bool fNewEvent;

  public:                                             // constructor
    TMvcEventProperties( TMidiEvent* aEvent, bool aNewEvent );
    ~TMvcEventProperties( );                          // destructor
    GtkWidget* GetWidget( void );                     // read widget
    void SetData( void );                             // set data to gui
    void GetData( void );                             // read data from gui
    void SetNoteValue( char* aButtonName );           // set the note value with buttons

    void SetEventType( short aEventType );            // set event type
    void SetEvent( TMidiEvent* aEvent );              // set other midi event
    void AdjustToMeasure( long aMeasure );            // adjust beat/ticks to selected measure
};

#endif