//=============================================================================
//  model view control KeySignature properties
//=============================================================================
// Author  : Adrian Meyer
// Version : 0.2.0
// Log     :
//=============================================================================
// 12.09.2000 building class
//============================================================================
// to do   :
//=============================================================================
#include <gtk/gtk.h>

#include "glade_interface.h"
#include "glade_support.h"

#include <mvcBase.h>
#include <mcSequence.h>
#include <mcStatics.h>

#ifndef __MVCKEYSIGNATUREPROPERTIES__
#define __MVCKEYSIGNATUREPROPERTIES__
class TMvcKeySignatureProperties: public TMvcBase
{
  private:
    GtkWidget* wndKeySignatureProperties;             // main window

    TMidiSequence* fSequence;                         // midi sequence
    GList* fKeySignaturesMajor;                       // key signature list major
    GList* fKeySignaturesMinor;                       // key signature list minor
    long fKeySignatureID;                             // KeySignature ID

  public:
                                                      // constructor
    TMvcKeySignatureProperties( TMidiSequence* aSequence, long aKeySignatureID );   
    ~TMvcKeySignatureProperties( void );              // destructor

    GtkWidget* GetWidget( void );                     // read widget

    void SetData( void );                             // set data to gui
    void GetData( void );                             // read data from gui
    void SetIsMinor( void );                          // set minor over radio button
};
#endif