//=============================================================================
//  model view control midi mapper properties
//=============================================================================
// Author  : Adrian Meyer
// Version : 0.3.0
// Log     :
//=============================================================================
// 20.07.2001 building class
// 22.07.2001 adding conf file
// 06.09.2001 adding presets
//=============================================================================
// to do   :
//=============================================================================
#include <gtk/gtk.h>

#include "glade_interface.h"
#include "glade_support.h"

#include <mvcBase.h>
#include <mvcInputBox.h>
#include <mcMapper.h>

#ifndef __MVCMAPPERPROPERTIES__
#define __MVCMAPPERPROPERTIES__

class TMvcMapperProperties: public TMvcBase
{
  private:
    GtkWidget* wndMapperProperties;                   // window
    TMidiMapper* fMapper;                             // device mapper
    GList* fPresetNames;                              // preset names

    void ValidateGui( void );                         // validate buttons on gui
  public:
                                                      // constructor
    TMvcMapperProperties( TMidiMapper* aMapper );
    ~TMvcMapperProperties( );                         // destructor
    GtkWidget* GetWidget( void );                     // read widget
    void SetData( void );                             // set data to gui
    void GetData( void );                             // read data from gui

    void AddPreset( void );                           // add a preset
    void DeletePreset( void );                        // delete a preset
    void SelectPreset( void );                        // select a preset
    char* GetSelectedPreset( void );                  // read selected preset name

};

#endif