//=============================================================================
//  model view control marker list
//=============================================================================
// Author  : Adrian Meyer
// Version : 0.2.2
// Log     :
//=============================================================================
// 11.09.2000 building class
// 12.09.2000 changed to fSelectedMarker (for selection in list)
// 10.04.2001 adding language file for property dialog
// 19.04.2001 changing to TMidiMarker
//============================================================================
// to do   :
//=============================================================================
#include <gtk/gtk.h>

#include "glade_interface.h"
#include "glade_support.h"

#include <mvcBase.h>
#include <mvcMarkerProperties.h>
#include <mcSequence.h>

class TMvcMarkerList: public TMvcBase
{
  private:
    GtkWidget* fWidget;                               // main widget
    TMidiMarker* fSelectedMarker;                     // selected marker

    TMidiSequence* fSequence;                         // sequence

    bool fMCMessageFlag;                              // message called
    TMvcMarkerProperties* fMarkerProperties;          // marker property dialog

  public:
                                                      // constructor
    TMvcMarkerList( GtkWidget* aWidget, TMidiSequence* aSequence );

    GtkWidget* GetWidget( void );                     // read widget
    void SetData( void );                             // set data
    void SetRowData( int aRow );                      // set data of a row

    void SetSelectedRow( int aRow );                  // write selected row
    void ValidateGui( void );                         // validate gui
    void MCMessage( TMidiBase* aMidiBase, sMCMessage* aMCMessage );

    void DeleteMarker( void );                        // delete selected marker
    void AddMarker( void );                           // add new marker
    void ShowMarkerProperties( void );                // show marker properties
};
