//=============================================================================
//  model view control Marker properties
//=============================================================================
// Author  : Adrian Meyer
// Version : 0.2.0
// Log     :
//=============================================================================
// 11.09.2000 building class
// 12.09.2000 added setting offset
//============================================================================
// to do   :
//=============================================================================
#include <gtk/gtk.h>

#include "glade_interface.h"
#include "glade_support.h"

#include <mvcBase.h>
#include <mcSequence.h>

#ifndef __MVCMARKERPROPERTIES__
#define __MVCMARKERPROPERTIES__
class TMvcMarkerProperties: public TMvcBase
{
  private:
    GtkWidget* wndMarkerProperties;                   // main window

    TMidiSequence* fSequence;                         // midi sequence
    TMidiMarker* fMarker;                             // marker ID

  public:
                                                      // constructor
    TMvcMarkerProperties( TMidiSequence* aSequence, TMidiMarker* aMarker );
    ~TMvcMarkerProperties( void );                    // destructor

    GtkWidget* GetWidget( void );                     // read widget

    void SetData( void );                             // set data to gui
    void GetData( void );                             // read data from gui
    void AdjustToMeasure( long aMeasure );            // adjust beat/ticks to selected measure
};
#endif