//=============================================================================
//  model view control MessageBox implementation
//=============================================================================
#include <mvcBase.h>
#include <mvcMessageBox.h>

// callbacks
void OkClicked( GtkButton *button, gpointer user_data );
void CancelClicked( GtkButton *button, gpointer user_data );
void YesClicked( GtkButton *button, gpointer user_data );
void NoClicked( GtkButton *button, gpointer user_data );
void BoxClosed( GtkObject *object, gpointer user_data );

//=============================================================================
// construtor MvcMessageBox														22.03.2000 Adrian Meyer
//=============================================================================
TMvcMessageBox::TMvcMessageBox( void )
{
	CreateMessageBox();
}

//=============================================================================
// create the box																			22.03.2000 Adrian Meyer
//=============================================================================
void TMvcMessageBox::CreateMessageBox( void )
{
  accel_group = gtk_accel_group_new ();

  wndMessageBox = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (wndMessageBox, "wndMessageBox");
  gtk_object_set_data (GTK_OBJECT (wndMessageBox), "wndMessageBox", wndMessageBox);
  gtk_window_set_title (GTK_WINDOW (wndMessageBox), "Message");
  gtk_window_set_position (GTK_WINDOW (wndMessageBox), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (wndMessageBox), TRUE);
  gtk_window_set_policy (GTK_WINDOW (wndMessageBox), FALSE, TRUE, TRUE);

  vboMain = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vboMain, "vboMain");
  gtk_widget_ref (vboMain);
  gtk_object_set_data_full (GTK_OBJECT (wndMessageBox), "vboMain", vboMain,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vboMain);
  gtk_container_add (GTK_CONTAINER (wndMessageBox), vboMain);

  lblMessage = gtk_label_new ("Message text");
  gtk_widget_set_name (lblMessage, "lblMessage");
  gtk_widget_ref (lblMessage);
  gtk_object_set_data_full (GTK_OBJECT (wndMessageBox), "lblMessage", lblMessage,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (lblMessage);
  gtk_box_pack_start (GTK_BOX (vboMain), lblMessage, TRUE, TRUE, 40);
  gtk_misc_set_padding (GTK_MISC (lblMessage), 8, 0);

  sepMain = gtk_hseparator_new ();
  gtk_widget_set_name (sepMain, "sepMain");
  gtk_widget_ref (sepMain);
  gtk_object_set_data_full (GTK_OBJECT (wndMessageBox), "sepMain", sepMain,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (sepMain);
  gtk_box_pack_start (GTK_BOX (vboMain), sepMain, FALSE, FALSE, 0);

  hbuttonbox1 = gtk_hbutton_box_new ();
  gtk_widget_set_name (hbuttonbox1, "hbuttonbox1");
  gtk_widget_ref (hbuttonbox1);
  gtk_object_set_data_full (GTK_OBJECT (wndMessageBox), "hbuttonbox1", hbuttonbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox1);
  gtk_box_pack_end (GTK_BOX (vboMain), hbuttonbox1, FALSE, FALSE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox1), GTK_BUTTONBOX_SPREAD);

  btnYes = gtk_button_new_with_label ("");
  btnYes_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (btnYes)->child),
                                   "_Yes");
  gtk_widget_add_accelerator (btnYes, "clicked", accel_group,
                              btnYes_key, GDK_MOD1_MASK, (GtkAccelFlags)0);
  gtk_widget_set_name (btnYes, "btnYes");
  gtk_widget_ref (btnYes);
  gtk_object_set_data_full (GTK_OBJECT (wndMessageBox), "btnYes", btnYes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btnYes);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), btnYes);
  GTK_WIDGET_SET_FLAGS (btnYes, GTK_CAN_DEFAULT);

  btnNo = gtk_button_new_with_label ("");
  btnNo_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (btnNo)->child),
                                   "_No");
  gtk_widget_add_accelerator (btnNo, "clicked", accel_group,
                              btnNo_key, GDK_MOD1_MASK, (GtkAccelFlags)0);
  gtk_widget_set_name (btnNo, "btnNo");
  gtk_widget_ref (btnNo);
  gtk_object_set_data_full (GTK_OBJECT (wndMessageBox), "btnNo", btnNo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btnNo);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), btnNo);
  GTK_WIDGET_SET_FLAGS (btnNo, GTK_CAN_DEFAULT);

  btnOK = gtk_button_new_with_label ("");
  btnOK_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (btnOK)->child),
                                   "_OK");
  gtk_widget_add_accelerator (btnOK, "clicked", accel_group,
                              btnOK_key, GDK_MOD1_MASK, (GtkAccelFlags)0);
  gtk_widget_set_name (btnOK, "btnOK");
  gtk_widget_ref (btnOK);
  gtk_object_set_data_full (GTK_OBJECT (wndMessageBox), "btnOK", btnOK,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btnOK);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), btnOK);
  GTK_WIDGET_SET_FLAGS (btnOK, GTK_CAN_DEFAULT);

  btnCancel = gtk_button_new_with_label ("");
  btnCancel_key = gtk_label_parse_uline (GTK_LABEL (GTK_BIN (btnCancel)->child),
                                   "_Cancel");
  gtk_widget_add_accelerator (btnCancel, "clicked", accel_group,
                              btnCancel_key, GDK_MOD1_MASK, (GtkAccelFlags)0);
  gtk_widget_set_name (btnCancel, "btnCancel");
  gtk_widget_ref (btnCancel);
  gtk_object_set_data_full (GTK_OBJECT (wndMessageBox), "btnCancel", btnCancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (btnCancel);
  gtk_container_add (GTK_CONTAINER (hbuttonbox1), btnCancel);
  GTK_WIDGET_SET_FLAGS (btnCancel, GTK_CAN_DEFAULT);

  gtk_window_add_accel_group (GTK_WINDOW (wndMessageBox), accel_group);

	gtk_signal_connect( GTK_OBJECT( btnOK ), "clicked", (GtkSignalFunc)OkClicked, this );
	gtk_signal_connect( GTK_OBJECT( btnCancel ), "clicked", (GtkSignalFunc)CancelClicked, this );
	gtk_signal_connect( GTK_OBJECT( btnYes ), "clicked", (GtkSignalFunc)YesClicked, this );
	gtk_signal_connect( GTK_OBJECT( btnNo ), "clicked", (GtkSignalFunc)NoClicked, this );
	gtk_signal_connect( GTK_OBJECT( wndMessageBox ), "destroy", (GtkSignalFunc)BoxClosed, this );
}

//=============================================================================
// destrutor MvcMessageBox														22.03.2000 Adrian Meyer
//=============================================================================
TMvcMessageBox::~TMvcMessageBox( void )
{
	ResetWidget();
}

//=============================================================================
// show message box																		22.03.2000 Adrian Meyer
//=============================================================================
short TMvcMessageBox::Show( char* aTitel, char* aMessage, short Buttons )
{
	if ( wndMessageBox == 0 ) { CreateMessageBox(); }		// box not here

	fResult = mrNone;																		// init. result

  gtk_window_set_title( GTK_WINDOW( wndMessageBox ), aTitel );
  gtk_label_set_text( GTK_LABEL( lblMessage ), aMessage );

	gtk_widget_hide( btnOK );
	gtk_widget_hide( btnCancel );
	gtk_widget_hide( btnYes );
	gtk_widget_hide( btnNo );

  if ( Buttons & mrCancel )
	{
		gtk_widget_show( btnCancel );
		gtk_window_set_focus( GTK_WINDOW( wndMessageBox ), btnCancel );
	}

  if ( Buttons & mrNo )
	{
		gtk_widget_show( btnNo );
		gtk_window_set_focus( GTK_WINDOW( wndMessageBox ), btnNo );
	}

  if ( Buttons & mrYes )
	{
		gtk_widget_show( btnYes );
		gtk_window_set_focus( GTK_WINDOW( wndMessageBox ), btnYes );
	}

  if ( Buttons & mrOK)
	{	
		gtk_widget_show( btnOK );
		gtk_window_set_focus( GTK_WINDOW( wndMessageBox ), btnOK );
	}

	gtk_widget_show( wndMessageBox );

	while ( fResult == mrNone )													// wait for result
		{	gtk_main_iteration();	}

	return fResult;
}

//=============================================================================
// read main widget																		24.03.2000 Adrian Meyer
//=============================================================================
GtkWidget* TMvcMessageBox::GetWidget( void )
{
	return wndMessageBox;
}

//=============================================================================
// reset widget																				24.03.2000 Adrian Meyer
//=============================================================================
void TMvcMessageBox::ResetWidget( void )
{
	if ( wndMessageBox != 0 ) { gtk_widget_destroy( wndMessageBox ); }
	wndMessageBox = 0;
}

//=============================================================================
// set result																					24.03.2000 Adrian Meyer
//=============================================================================
void TMvcMessageBox::SetResult( short aResult )
{
	fResult = aResult;
}

//=============================================================================
// ok clicked																					24.03.2000 Adrian Meyer
//=============================================================================
void OkClicked( GtkButton *button, gpointer user_data )
{
	gtk_widget_hide( (( TMvcMessageBox*)user_data)->GetWidget( ));
	((TMvcMessageBox*)user_data )->SetResult( mrOK );
}

//=============================================================================
// cancel clicked																			24.03.2000 Adrian Meyer
//=============================================================================
void CancelClicked( GtkButton *button, gpointer user_data )
{
	gtk_widget_hide( (( TMvcMessageBox*)user_data)->GetWidget( ));
	((TMvcMessageBox*)user_data )->SetResult( mrCancel );
}

//=============================================================================
// yes clicked																				24.03.2000 Adrian Meyer
//=============================================================================
void YesClicked( GtkButton *button, gpointer user_data )
{
	gtk_widget_hide( (( TMvcMessageBox*)user_data)->GetWidget( ));
	((TMvcMessageBox*)user_data )->SetResult( mrYes );
}

//=============================================================================
// ok clicked																					24.03.2000 Adrian Meyer
//=============================================================================
void NoClicked( GtkButton *button, gpointer user_data )
{
	gtk_widget_hide( (( TMvcMessageBox*)user_data)->GetWidget( ));
	((TMvcMessageBox*)user_data )->SetResult( mrNo );
}

//=============================================================================
// box closed																					24.03.2000 Adrian Meyer
//=============================================================================
void BoxClosed( GtkObject *object, gpointer user_data )
{
	(( TMvcMessageBox*)user_data)->ResetWidget();
	((TMvcMessageBox*)user_data )->SetResult( mrCancel );
}