//=============================================================================
//  model view control song properties
//=============================================================================
#include <mvcSongProperties.h>
#include <mcStatics.h>
#include <iostream.h>
#include <string.h>

// callbacks
void OkClickedSongProp( GtkButton *button, gpointer user_data );
void CancelClickedSongProp( GtkButton *button, gpointer user_data );

//=============================================================================
// construtor MvcMain																	24.03.2000 Adrian Meyer
//=============================================================================
TMvcSongProperties::TMvcSongProperties( TMidiSequence* aSequence )
{
  wndSongProperties = create_wndSongProperties();			// call glade
	AddChildrenToWidgetList( wndSongProperties );       // fetch widgets
	fSequence = aSequence;

  HookSignal( "btnOk", "clicked", GTK_SIGNAL_FUNC( OkClickedSongProp ), this );
  HookSignal( "btnCancel", "clicked", GTK_SIGNAL_FUNC( CancelClickedSongProp ), this );

	if ( aSequence == 0 ) return;

  gtk_widget_show( wndSongProperties );							

	SetData();																					// set data to gui
}

//=============================================================================
// destrutor MvcMain						 											09.03.2000 Adrian Meyer
//=============================================================================
TMvcSongProperties::~TMvcSongProperties( void )
{
	delete wndSongProperties;
}

//=============================================================================
// set data to gui																		27.03.2000 Adrian Meyer
//=============================================================================
void TMvcSongProperties::SetData( void )
{
	int* tmpInt = new int = 0;

	gtk_editable_insert_text( GTK_EDITABLE( FindWidget( "txtName" )),
		fSequence->GetSequenceName(),
		strlen( fSequence->GetSequenceName()), tmpInt );

	gtk_entry_set_text( GTK_ENTRY( FindWidget( "edtCopyright" )),
		fSequence->GetCopyrightNotice());

	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( FindWidget( "chkUseRunningStatus" )),
		fSequence->GetUseRunningStatus());		

	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( FindWidget( "rboUseNoteOff" )),
		fSequence->GetUseNoteOff());		

	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( FindWidget( "rboUseNoteOn" )),
		!fSequence->GetUseNoteOff());		

  gtk_spin_button_set_value( GTK_SPIN_BUTTON( FindWidget( "spiResolution" )),
		fSequence->GetDeltaTimesType() );

//	txtName
}

//=============================================================================
// read data from gui into object											27.03.2000 Adrian Meyer
//=============================================================================
void TMvcSongProperties::GetData( void )
{
	fSequence->SetSequenceName(
		gtk_editable_get_chars( GTK_EDITABLE( FindWidget( "txtName" )),
		0, gtk_text_get_length( GTK_TEXT( FindWidget( "txtName" )))));	

	fSequence->SetCopyrightNotice(
		gtk_entry_get_text( GTK_ENTRY( FindWidget( "edtCopyright" ))));

	fSequence->SetUseRunningStatus(
		gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( FindWidget( "chkUseRunningStatus" ))));

	fSequence->SetUseNoteOff(
		gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( FindWidget( "rboUseNoteOff" ))));

	fSequence->SetDeltaTimesType(	
	  gtk_spin_button_get_value_as_int( GTK_SPIN_BUTTON( FindWidget( "spiResolution" ))));
}

//=============================================================================
// read widget																				27.03.2000 Adrian Meyer
//=============================================================================
GtkWidget* TMvcSongProperties::GetWidget( void )
{
	return wndSongProperties;
}

//=============================================================================
// ok clicked																					27.03.2000 Adrian Meyer
//=============================================================================
void OkClickedSongProp( GtkButton *button, gpointer user_data )
{
	gtk_widget_hide( ((TMvcSongProperties*)user_data)->GetWidget() );
	((TMvcSongProperties*)user_data)->GetData();
}

//=============================================================================
// cancel clicked																			27.03.2000 Adrian Meyer
//=============================================================================
void CancelClickedSongProp( GtkButton *button, gpointer user_data )
{
	gtk_widget_hide( ((TMvcSongProperties*)user_data)->GetWidget() );
}