//=============================================================================
//  model view control time signature list
//=============================================================================
// Author  : Adrian Meyer
// Version : 0.2.1
// Log     :
//=============================================================================
// 12.09.2000 building class
// 10.04.2001 adding language file for property dialog
//============================================================================
// to do   :
//=============================================================================
#include <gtk/gtk.h>

#include "glade_interface.h"
#include "glade_support.h"

#include <mvcBase.h>
#include <mvcTimeSignatureProperties.h>
#include <mcSequence.h>

class TMvcTimeSignatureList: public TMvcBase
{
  private:
    GtkWidget* fWidget;                               // main widget
    sTimeSignatureList* fSelectedTimeSignature;       // selected row

    TMidiSequence* fSequence;                         // sequence

    bool fMCMessageFlag;                              // message called

                                                      // TimeSignature property dialog
    TMvcTimeSignatureProperties* fTimeSignatureProperties;          
  public:
                                                      // constructor
    TMvcTimeSignatureList( GtkWidget* aWidget, TMidiSequence* aSequence );

    GtkWidget* GetWidget( void );                     // read widget
    void SetData( void );                             // set data
    void SetRowData( int aRow );                      // set data of a row

    void SetSelectedRow( int aRow );                  // write selected row
    void ValidateGui( void );                         // validate gui
    void MCMessage( TMidiBase* aMidiBase, sMCMessage* aMCMessage );

    void DeleteTimeSignature( void );                 // delete selected TimeSignature
    void AddTimeSignature( void );                    // add new TimeSignature
    void ShowTimeSignatureProperties( void );         // show TimeSignature properties
};
