//=============================================================================
//  model view control track properties
//=============================================================================
// Author  : Adrian Meyer
// Version : 0.3.0
// Log     :
//=============================================================================
// 27.03.2000 building class
// 21.10.2001 adding mapper class
//            adding port handling of track
//============================================================================
// to do   :
//=============================================================================
#include <gtk/gtk.h>

#include "glade_interface.h"
#include "glade_support.h"

#include <mvcBase.h>
#include <mcTrack.h>
#include <mcMapper.h>

#ifndef __MVCTRACKPROPERTIES__
#define __MVCTRACKPROPERTIES__
class TMvcTrackProperties: public TMvcBase
{
  private:
    GtkWidget* wndTrackProperties;                    // main window
    TMidiTrack* fTrack;                               // midi track
    TMidiMapper* fMapper;                             // midi mapper
    GList* fGMPatchNames;                             // List with patch names
    GList* fPortNames;                                // List with port names
    GdkColor* colTrackColor;                          // track color

  public:                                             // constructor
    TMvcTrackProperties( TMidiTrack* aTrack, TMidiMapper* aMapper );
    ~TMvcTrackProperties( );                          // destructor
    GtkWidget* GetWidget( void );                     // read widget
    void SetData( void );                             // set data to gui
    void GetData( void );                             // read data from gui
    void SetEventType( short aEventType );            // set event type
};
#endif